<% projects.each do |project| %>
  <div class="card mb-2">
    <div class="card-header">
      <%= link_to_if project.web_url, project.name, project.web_url %>
    </div>
    <div class="card-body px-0 pt-0">
      <table class="table table-striped mx-0">
        <thead class="table-light">
          <tr>
            <th scope="col">Enabled</th>
            <th scope="col">Package ecosystem</th>
            <th scope="col">Directory</th>
            <th scope="col">Cron</th>
            <th scope="col">Last executed</th>
            <th scope="col">Last execution errors</th>
            <th scope="col">Open merge requests</th>
            <th scope="col">Actions</th>
          </tr>
        </thead>
        <tbody class="table-group-divider" data-controller="job">
          <% if project.update_jobs.empty? %>
            <tr>
              <td colspan="8">No jobs configured</td>
            </tr>
          <% else %>
            <div>
              <% project.update_jobs.each do |job| %>
                <% project_name = project.name %>
                <% ecosystem = job.package_ecosystem %>
                <% directory = job.directory %>
                <% config_entry = project.configuration.entry(package_ecosystem: ecosystem, directory: directory) %>
                <% next log(:error, "Tried to render job entry but missing configuration entry for project '#{project_name}=>#{ecosystem}=>#{directory}'") unless config_entry %>
                <tr>
                  <td>
                    <div class="form-check form-switch">
                      <%= check_box_tag "toggle",
                                        job_toggle_path(job.id),
                                        job.enabled,
                                        autocomplete: :off,
                                        class: "form-check-input",
                                        data: {
                                          action: "job#toggle",
                                          testid: "#{project_name}-#{ecosystem}-#{directory}-toggle"
                                        }
                      %>
                    </div>
                  </td>
                  <td><%= ecosystem %></td>
                  <td><%= directory %></td>
                  <td><%= job.cron %></td>
                  <% last_executed = job.last_executed %>
                  <td><%= "#{time_ago_in_words(last_executed)} ago" if last_executed %>
                  <td><%= job.last_failures %></td>
                  <td>
                    <%=
                      mrs = open_merge_requests(project, job.package_ecosystem, job.directory).length
                      link_to_if(mrs > 0, mrs, open_mrs_url(project, config_entry))
                    %>
                  </td>
                  <td>
                    <button class="btn btn-primary btn-sm"
                            data-action="job#execute"
                            data-testid="<%= "#{project_name}-#{ecosystem}-#{directory}-execute"%>"
                            data-url="<%= job_execute_path(job.id) %>"
                    >
                      Execute
                    </button>
                  </td>
                </tr>
              <% end %>
            </div>
          <% end %>
        </tbody>
      </table>
      <div class="d-flex ms-2">
        <%= button_to "Sync", project_path(project.id), method: :put, title: "Sync project configuration", class: "btn btn-primary btn-sm me-1" %>
        <button type="button" class="btn btn-danger btn-sm" title="Delete project" id="delete-project" data-bs-toggle="modal" data-bs-target="#delete-project-modal-<%= project.id %>">Delete</button>
      </div>
      <%# TODO: remove hacky modal duplicates when single project page is implemented %>
      <%= render partial: "delete_project", locals: { id: project.id } %>
    </div>
  </div>
<% end %>
<%= paginate projects %>
